/* analyze.dbck
 *
 * Plocka ut info om textstorlekar.
 */

object re = Regexp("^[ \t]*([0-9][0-9]*) ([0-9][0-9]*).*$");
		   
int main(int argc, array(string) argv)
{
  array(string) lines = Stdio.File("stdin")->read(0x7fffffff) / "\n";
  array(array(int)) input
    = Array.map(Array.map(lines, re->split) - ({ 0 }), lambda(array(string) a)
    {
      return Array.map(a, lambda(string s) { return (int) s; });
    } );
    
  // write(sprintf("Input: %O\n", input));

  int power = 1;
  int no = 0; int total_no = 0;
  int db_size = 0; int real_size = 0;
  int total_db_size = 0; int total_real_size = 0;

  write("Power of 2  number of    total       text     aligned       total  total aligned\n"
	"            texts                    size     size          size   size\n\n");
  int i = 0;
  while(1)
    {
      if ((i == sizeof(input))
	  || (input[i][0] > power))
	{
	  total_no += no;
	  total_db_size += db_size;
	  total_real_size += real_size;
	  write(sprintf("    %6d     %6d   %6d  %9d   %9d  %9d       %9d\n",
			power, no, total_no, real_size, db_size,
			total_real_size, total_db_size));
	  if (i == sizeof(input))
	    break;
	  no = db_size = real_size = 0;
	  power *= 2; 
	}
      else
	{
	  no += input[i][1];
	  real_size += `*(@input[i]);
	  db_size += power * input[i][1];
	  i++;
	}
    }
  return 0;
}
